/* ###################################################################
**     This component module is generated by Processor Expert. Do not modify it.
**     Filename    : SPI0.h
**     Project     : DEVKIT-S12ZVL-Lab5SPI
**     Processor   : MC9S12ZVL32MLF
**     Component   : Init_SPI
**     Version     : Component 01.083, Driver 01.09, CPU db: 3.00.000
**     Compiler    : CodeWarrior HCS12Z C Compiler
**     Date/Time   : 2016-05-09, 15:58, # CodeGen: 1
**     Abstract    :
**          This file implements the SPI (SPI0)
**          module initialization according to the Peripheral Initialization
**          Component settings, and defines interrupt service routines prototypes.
**          The SPI includes these distinctive features:
**           Master mode and slave mode
**           Bi-directional mode
**           Slave select output
**           Mode fault error flag with CPU interrupt capability
**           Double-buffered data register
**           Serial clock with programmable polarity and phase
**           Control of SPI operation during wait mode

**     Settings    :
**          Component name                                 : SPI0
**          Device                                         : SPI0
**          Value of Preselection                          : 4
**          Value of Selection                             : 2
**          Frequency                                      : 500 kHz
**          Mode Select                                    : Master
**          SS pin mode                                    : Automatic Slave Select output
**          Allocate SS pin                                : Enabled
**          SS pin                                         : PS3_KWS3_SS0_IOC0_5_ECLK
**          SS pin signal                                  : 
**          Clock Polarity                                 : active-high
**          Clock Phase                                    : Second edge
**          Data shift order                               : MSB first
**          Bidirectional Mode                             : Disabled
**          Stop in Wait Mode                              : no
**          Output enable in Bidirect.                     : no
**          MISO pin                                       : PS0_KWS0_MISO0_PWM4_RXD0_IOC0_2
**          MISO pin signal                                : 
**          MOSI pin                                       : PS1_KWS1_MOSI0_PWM6_TXD0_LPDC0_IOC0_3
**          MOSI pin signal                                : 
**          SCK pin                                        : PS2_KWS2_SCK0_IOC0_4_DBGEEV
**          SCK pin signal                                 : 
**          Interrupt                                      : Vspi0
**          SPI receive interrupt                          : Disabled
**          SPI transmit interrupt                         : Disabled
**          Interrupt Priority                             : 1
**          ISR name                                       : 
**          Call Init in CPU init. code                    : yes
**          Enable SPI system                              : yes
**     Contents    :
**         Init - void SPI0_Init(void);
**
**     Copyright : 1997 - 2014 Freescale Semiconductor, Inc. 
**     All Rights Reserved.
**     
**     Redistribution and use in source and binary forms, with or without modification,
**     are permitted provided that the following conditions are met:
**     
**     o Redistributions of source code must retain the above copyright notice, this list
**       of conditions and the following disclaimer.
**     
**     o Redistributions in binary form must reproduce the above copyright notice, this
**       list of conditions and the following disclaimer in the documentation and/or
**       other materials provided with the distribution.
**     
**     o Neither the name of Freescale Semiconductor, Inc. nor the names of its
**       contributors may be used to endorse or promote products derived from this
**       software without specific prior written permission.
**     
**     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
**     ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
**     WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
**     DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
**     ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
**     (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
**     LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
**     ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
**     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
**     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**     
**     http: www.freescale.com
**     mail: support@freescale.com
** ###################################################################*/
/*!
** @file SPI0.h
** @version 01.09
** @brief
**          This file implements the SPI (SPI0)
**          module initialization according to the Peripheral Initialization
**          Component settings, and defines interrupt service routines prototypes.
**          The SPI includes these distinctive features:
**           Master mode and slave mode
**           Bi-directional mode
**           Slave select output
**           Mode fault error flag with CPU interrupt capability
**           Double-buffered data register
**           Serial clock with programmable polarity and phase
**           Control of SPI operation during wait mode

*/         
/*!
**  @addtogroup SPI0_module SPI0 module documentation
**  @{
*/         

#ifndef __SPI0
#define __SPI0

/* MODULE SPI0. */

/*Include shared modules, which are used for whole project*/
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
/* Include inherited components */

#include "Cpu.h"




void SPI0_Init(void);
/*
** ===================================================================
**     Method      :  SPI0_Init (component Init_SPI)
**     Description :
**         This method initializes registers of the SPI module
**         according to this Peripheral Initialization Component settings.
**         Call this method in user code to initialize the module.
**         By default, the method is called by PE automatically; see
**         "Call Init method" property of the component for more details.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

/* END SPI0. */
#endif /* ifndef __SPI0 */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.09]
**     for the Freescale HCS12Z series of microcontrollers.
**
** ###################################################################
*/
